<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="defaultData"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const permissions = ref([]);

const defaultData = ref({});

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'group_name',
            label: $i18n.t('name'),
        },
        {
            type: 'checkbox',
            name: 'permissions[]',
            label: $i18n.t('permission'),
            options: Object.keys(permissions.value).map(key => {
                return {
                    value: String(key),
                    text: String(permissions.value[key])
                };
            }),
            multiple: true
        }
    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/management/admin_group/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/management/admin_group/build_form', {
            id: props.formModel ? props.formModel.id : '',
        });

        if (data.model) {
            model.value = data.model;

            if (props.formModel) {
                defaultData.value = data.model;
                if (data.model.permissions) {
                    defaultData.value['permissions[]'] = data.model.permissions.map(r => {
                        return String(r.permission_tag);
                    });
                }
            }
        }

        if (data.permissions) {
            permissions.value = data.permissions;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
